<?php

class rdc_wc_eclairage extends hook
{
	public $hookName = "rdc_wc_eclairage";
	public $active = true;			//enable/disable hook (true => enabled)

	protected $devicelist = array(
				RDC_SDB_WC_ECLAIRAGE => "state_l2",
				RDC_WC_MVMT => "occupancy"
				);

	public $delay = 3;				// amount of time in $timeunit
	public $delayManual = 10;		// amount of time in $timeunit for manual mode
	public $timeUnit = "minute";	// unit of time for delay, second, minute, day, week, month, year

	// callback fonction. Is called with these 4 parameters
	public function callBack(&$device, $property, $value)
	{
		global $indexDevices;

		$targetDevice = &$indexDevices[RDC_SDB_WC_ECLAIRAGE];		//var_dump($value);
		logger(DEBUG, "Callback : " . $this->hookName, __FILE__ . ":" . __LINE__);
		switch($property)
		{
			case "state_l2":
				logger(DEBUG, "CASE: state_l2", __FILE__ . ":" . __LINE__);
				if ($value == "ON")
				{
					logger(DEBUG, "method =" . $targetDevice->properties["state_l2"]["method"], __FILE__ . ":" . __LINE__);
					if ($targetDevice->properties["state_l2"]["method"] == IDLE)
					{
						$targetDevice->properties["state_l2"]["method"] = MANUAL;
						setDelay($targetDevice, $this->delayManual, $this->timeUnit, "state_l2", "OFF", true);
					}
				}elseif ($value == "OFF")
				{
					$targetDevice->properties["state_l2"]["method"] = IDLE;
					removeEvent($targetDevice, "state_l2", "OFF");
				}
				break;
			case "occupancy":
				logger(DEBUG, "CASE: WC occupancy", __FILE__ . ":" . __LINE__);
				logger(DEBUG, "method =" . $targetDevice->properties["state_l2"]["method"], __FILE__ . ":" . __LINE__);
				if ($value === true and $targetDevice->properties["state_l2"]["method"] == IDLE)
				{
					//$targetDevice->properties["state_l2"]["method"] = AUTO;
					$this->send($targetDevice, "ON", AUTO);
				}elseif ($value === false and $targetDevice->properties["state_l2"]["method"] == AUTO)
				{
					//$targetDevice->properties["state_l2"]["method"] = IDLE;
					//$this->send($targetDevice, "OFF");
					setDelay($targetDevice, $this->delay, $this->timeUnit, "state_l2", "OFF", true, IDLE);
				}
		}
		logger (INFO, sprintf(_("%s: notification received from MQTT from %s => parameter: %s value: %s"), $this->hookName, $device->friendlyName, $property, bool2string($value)), __FILE__ . ":" . __LINE__);
	}
	private function send($targetDevice, $state, $method = IDLE)
	{
		global $indexDevices;

		$msg = array("state_l2" => $state);
		logger(INFO, sprintf(_("publishing message: %s to %s"), json_encode($msg), $targetDevice->friendlyName), __FILE__ . ":" . __LINE__);
		$targetDevice->payload = $msg;
		$targetDevice->set("state_l2", $method);
	}
}

$hooks["rdc_wc_eclairage"] = new rdc_wc_eclairage();
?>
